{-----------------------------------------------------------------------------}
{ Lexical analisys initialization part.                          (c) 1992 YGP }

  procedure lex_init;
    type bap = ^ba;
         ba = packed array [0..127] of byte;

    var c: packed array [#0..#127] of byte;

    const _i_4_modes = _i_imd + _i_Zpg + _i_ndx + _i_abs;
          _i_2_modes =                   _i_ndx + _i_abs;
          _i_lng =     _i_wrd - _i_imd;  { long (word operand) immediate mode }

    var n_cmd2, n_cmd4: shortcard;   {   ( pack_name 2  4 ) }
        n_cmd6: shortcard;   {   ( pack_name 6  (9 )) }
        cmd2: array [byte] of word;         {      2  }
        cmd4: array [byte] of longword;     {      4  }
        cmd6: array [byte] of             {      6  }
              packed array [0..5] of char;
        cmd2_instr,                           {     }
        cmd4_instr: array [byte] of instr_descriptor;
        cmd2_dir,                              {     }
        cmd4_dir,
        cmd6_dir: d_array;

    procedure def_cmd((*)const(*) i_name: string; code, mode: byte);
      var pos: natural; (* wrk: string; *)
    begin { def_cmd }
      (* wrk:= i_name; UpcaseS(wrk); pack_size:= pack_ident(wrk, pack_name); *)
      pack_size:= pack_ident(i_name, pack_name);
      case pack_size of
        1: begin
          if search2(pack_name[4], cmd2, n_cmd2, pos) then
            error(se_dcmd1)         { if already defined then signal an error }
          else begin
            move(cmd2[pos], cmd2[pos+1], sizeof(cmd2[pos])*(n_cmd2-pos));
            move(cmd2_instr[pos],
                 cmd2_instr[pos+1], sizeof(cmd2_instr[pos])*(n_cmd2-pos));
            cmd2[pos]:= pack_name[4];
            with cmd2_instr[pos] do begin
              opcode:= code; flags:= mode;
            end { with };
            inc(n_cmd2);
          end { if };
        end { when 2 bytes packed name };

        2: begin
          if search4(longword(addr(pack_name[3])^), cmd4, n_cmd4, pos) then
            error(se_dcmd2)         { if already defined then signal an error }
          else begin
            move(cmd4[pos], cmd4[pos+1], sizeof(cmd4[pos])*(n_cmd4-pos));
            move(cmd4_instr[pos],
                 cmd4_instr[pos+1], sizeof(cmd4_instr[pos])*(n_cmd4-pos));
            cmd4[pos]:= longword(addr(pack_name[3])^);
            with cmd4_instr[pos] do begin
              opcode:= code; flags:= mode;
            end { with };
            inc(n_cmd4);
          end { if };
        end { when 4 bytes packed name };

      else (*):(*)
        error(se_dcmd3);
      end { case };
    end { def_cmd };

    procedure def_dir((*)const(*) d_name: string; directv: directives);
      var pos: natural; (* wrk: string; *)
    begin { def_dir }
      (* wrk:= d_name; UpcaseS(wrk); pack_size:= pack_ident(wrk, pack_name); *)
      pack_size:= pack_ident(d_name, pack_name);
      case pack_size of
        1: begin
          if search2(pack_name[4], cmd2, n_cmd2, pos) then
            error(se_ddir1)         { if already defined then signal an error }
          else begin
            move(cmd2[pos], cmd2[pos+1], sizeof(cmd2[pos])*(n_cmd2-pos));
            move(cmd2_dir[pos],
                 cmd2_dir[pos+1], sizeof(cmd2_dir[pos])*(n_cmd2-pos));
            cmd2[pos]:= pack_name[4];
            cmd2_dir[pos]:= directv;
            inc(n_cmd2);
          end { if };
        end { when 2 bytes packed name };

        2: begin
          if search4(longword(addr(pack_name[3])^), cmd4, n_cmd4, pos) then
            error(se_ddir2)         { if already defined then signal an error }
          else begin
            move(cmd4[pos], cmd4[pos+1], sizeof(cmd4[pos])*(n_cmd4-pos));
            move(cmd4_dir[pos],
                 cmd4_dir[pos+1], sizeof(cmd4_dir[pos])*(n_cmd4-pos));
            cmd4[pos]:= longword(addr(pack_name[3])^);
            cmd4_dir[pos]:= directv;
            inc(n_cmd4);
          end { if };
        end { when 4 bytes packed name };

        3: begin
          if searchN(pack_name[2], cmd6, 6, n_cmd6, pos) then
            error(se_ddir3)         { if already defined then signal an error }
          else begin
            move(cmd6[pos], cmd6[pos+1], sizeof(cmd6[pos])*(n_cmd6-pos));
            move(cmd6_dir[pos],
                 cmd6_dir[pos+1], sizeof(cmd6_dir[pos])*(n_cmd6-pos));
            move(pack_name[2], cmd6[pos], 6);
            cmd6_dir[pos]:= directv;
            inc(n_cmd6);
          end { if };
        end { when 6 bytes packed name };

      else (*):(*)
        error(se_ddir4);
      end { case };
    end { def_dir };

    function mv2heap((*)const{*)var{*} who; size: natural): pointer;
      var p: pointer;
    begin
      p:= nil;
      if size <> 0 then begin
        (*) getmemwords(p, (size +1) div 2);
        {*) getmem(p, size); {*}
        move(who, p^, size);
      end { if };
      mv2heap:= p;
    end { mv2heap };

    procedure init_commands;
      const _ = 0;
    begin { init_commands }
      {       : A..Z, 0..9, _    }
      {    6 .                                                  }
      n_cmd2:= 0; n_cmd4:= 0;
      def_cmd('ABA',  $1b, _                  );
      def_cmd('ADCA', $89, _i_4_modes         );
      def_cmd('ADCB', $c9, _i_4_modes         );
      def_cmd('ADDA', $8b, _i_4_modes         );
      def_cmd('ADDB', $cb, _i_4_modes         );
      def_cmd('ANDA', $84, _i_4_modes         );
      def_cmd('ANDB', $c4, _i_4_modes         );
      def_cmd('ASL',  $48, _i_2_modes         );
      def_cmd('ASLA', $48, _                  );
      def_cmd('ASLB', $58, _                  );
      def_cmd('ASR',  $47, _i_2_modes         );
      def_cmd('ASRA', $47, _                  );
      def_cmd('ASRB', $57, _                  );
      def_cmd('BCC',  $24, _i_rel             );
      def_cmd('BCS',  $25, _i_rel             );
      def_cmd('BEQ',  $27, _i_rel             );
      def_cmd('BGE',  $2c, _i_rel             );
      def_cmd('BGT',  $2e, _i_rel             );
      def_cmd('BHI',  $22, _i_rel             );
      def_cmd('BITA', $85, _i_4_modes         );
      def_cmd('BITB', $c5, _i_4_modes         );
      def_cmd('BLE',  $2f, _i_rel             );
      def_cmd('BLS',  $23, _i_rel             );
      def_cmd('BLT',  $2d, _i_rel             );
      def_cmd('BMI',  $2b, _i_rel             );
      def_cmd('BNE',  $26, _i_rel             );
      def_cmd('BPL',  $2a, _i_rel             );
      def_cmd('BRA',  $20, _i_rel             );
      def_cmd('BSR',  $8d, _i_rel             );
      def_cmd('BVC',  $28, _i_rel             );
      def_cmd('BVS',  $29, _i_rel             );
      def_cmd('CBA',  $11, _                  );
      def_cmd('CLC',  $0c, _                  );
      def_cmd('CLI',  $0e, _                  );
      def_cmd('CLR',  $4f, _i_2_modes         );
      def_cmd('CLRA', $4f, _                  );
      def_cmd('CLRB', $5f, _                  );
      def_cmd('CLV',  $0a, _                  );
      def_cmd('CMPA', $81, _i_4_modes         );
      def_cmd('CMPB', $c1, _i_4_modes         );
      def_cmd('COM',  $43, _i_2_modes         );
      def_cmd('COMA', $43, _                  );
      def_cmd('COMB', $53, _                  );
      def_cmd('CPX',  $8c, _i_4_modes + _i_lng);
      def_cmd('DAA',  $19, _                  );
      def_cmd('DEC',  $4a, _i_2_modes         );
      def_cmd('DECA', $4a, _                  );
      def_cmd('DECB', $5a, _                  );
      def_cmd('DES',  $34, _                  );
      def_cmd('DEX',  $09, _                  );
      def_cmd('EORA', $88, _i_4_modes         );
      def_cmd('EORB', $c8, _i_4_modes         );
      def_cmd('INC',  $4c, _i_2_modes         );
      def_cmd('INCA', $4c, _                  );
      def_cmd('INCB', $5c, _                  );
      def_cmd('INS',  $31, _                  );
      def_cmd('INX',  $08, _                  );
      def_cmd('JMP',  $4e, _i_2_modes         );
      def_cmd('JSR',  $8d, _i_2_modes         );
      def_cmd('LDAA', $86, _i_4_modes         );
      def_cmd('LDAB', $c6, _i_4_modes         );
      def_cmd('LDS',  $8e, _i_4_modes + _i_lng);
      def_cmd('LDX',  $ce, _i_4_modes + _i_lng);
      def_cmd('LSR',  $44, _i_2_modes         );
      def_cmd('LSRA', $44, _                  );
      def_cmd('LSRB', $54, _                  );
      def_cmd('NEG',  $40, _i_2_modes         );
      def_cmd('NEGA', $40, _                  );
      def_cmd('NEGB', $50, _                  );
      def_cmd('NOP',  $01, _                  );
      def_cmd('ORAA', $8a, _i_4_modes         );
      def_cmd('ORAB', $ca, _i_4_modes         );
      def_cmd('PSHA', $36, _                  );
      def_cmd('PSHB', $37, _                  );
      def_cmd('PULA', $32, _                  );
      def_cmd('PULB', $33, _                  );
      def_cmd('ROL',  $49, _i_2_modes         );
      def_cmd('ROLA', $49, _                  );
      def_cmd('ROLB', $59, _                  );
      def_cmd('ROR',  $46, _i_2_modes         );
      def_cmd('RORA', $46, _                  );
      def_cmd('RORB', $56, _                  );
      def_cmd('RTI',  $3b, _                  );
      def_cmd('RTS',  $39, _                  );
      def_cmd('SBA',  $10, _                  );
      def_cmd('SBCA', $82, _i_4_modes         );
      def_cmd('SBCB', $c2, _i_4_modes         );
      def_cmd('SEC',  $0d, _                  );
      def_cmd('SEI',  $0f, _                  );
      def_cmd('SEV',  $0b, _                  );
      def_cmd('STAA', $87, _i_4_modes - _i_imd);
      def_cmd('STAB', $c7, _i_4_modes - _i_imd);
      def_cmd('STS',  $8f, _i_4_modes - _i_imd);
      def_cmd('STX',  $cf, _i_4_modes - _i_imd);
      def_cmd('SUBA', $80, _i_4_modes         );
      def_cmd('SUBB', $c0, _i_4_modes         );
      def_cmd('SWI',  $3f, _                  );
      def_cmd('TAB',  $16, _                  );
      def_cmd('TAP',  $06, _                  );
      def_cmd('TBA',  $17, _                  );
      def_cmd('TPA',  $07, _                  );
      def_cmd('TST',  $4d, _i_2_modes         );
      def_cmd('TSTA', $4d, _                  );
      def_cmd('TSTB', $5d, _                  );
      def_cmd('TSX',  $30, _                  );
      def_cmd('TXS',  $35, _                  );
      def_cmd('WAI',  $3e, _                  );
      def_cmd('INT',  $2f, _i_zpg             );

      n_instr2:= n_cmd2;               {        heap- }
      i_nm_2:= mv2heap(cmd2, n_cmd2 * sizeof(cmd2[0]));
      i_cd_2:= mv2heap(cmd2_instr, n_cmd2 * sizeof(cmd2_instr[0]));
      n_instr4:= n_cmd4;
      i_nm_4:= mv2heap(cmd4, n_cmd4 * sizeof(cmd4[0]));
      i_cd_4:= mv2heap(cmd4_instr, n_cmd4 * sizeof(cmd4_instr[0]));
    end { init_commands };

    procedure init_alternate;
    begin { init_alternate }
      {       : A..Z, 0..9, _    }
      {    6 .                                                  }
      n_cmd2:= 0; n_cmd4:= 0;
      def_cmd('CPA',  $81, _i_4_modes);
      def_cmd('CPB',  $c1, _i_4_modes);
      def_cmd('LDA',  $86, _i_4_modes);
      def_cmd('LDB',  $c6, _i_4_modes);
      def_cmd('ORA',  $8a, _i_4_modes);
      def_cmd('ORB',  $ca, _i_4_modes);
      def_cmd('PHA',  $36, 0);
      def_cmd('PHB',  $37, 0);
      def_cmd('PLA',  $32, 0);
      def_cmd('PLB',  $33, 0);
      def_cmd('STA',  $87, _i_4_modes - _i_imd);
      def_cmd('STB',  $c7, _i_4_modes - _i_imd);
      def_cmd('XORA', $88, _i_4_modes);
      def_cmd('XORB', $c8, _i_4_modes);

      n_alter2:= n_cmd2;               {        heap- }
      a_nm_2:= mv2heap(cmd2, n_cmd2 * sizeof(cmd2[0]));
      a_cd_2:= mv2heap(cmd2_instr, n_cmd2 * sizeof(cmd2_instr[0]));
      n_alter4:= n_cmd4;
      a_nm_4:= mv2heap(cmd4, n_cmd4 * sizeof(cmd4[0]));
      a_cd_4:= mv2heap(cmd4_instr, n_cmd4 * sizeof(cmd4_instr[0]));
    end { init_alternate };

    procedure init_directives;
    begin { init_directives }
      {       : A..Z, 0..9, _     }
      {    9 .                                                  }
      n_cmd2:= 0; n_cmd4:= 0; n_cmd6:= 0;

      def_dir('DEFINE',    d_define);
      def_dir('UNDEF',     d_undef);
      def_dir('IFDEF',     d_ifdef);
      def_dir('IFNDEF',    d_ifndef);
      def_dir('IF',        d_if);
      def_dir('ELSE',      d_else);
     {def_dir('ELSIF',     d_elsif);}
     {def_dir('ELSIFDEF',  d_elsifdef);}
     {def_dir('ELSIFNDEF', d_elsifNdef);}
      def_dir('ENDIF',     d_endif);

      def_dir('EQU',       d_equ);
      def_dir('ERROR',     d_error);
     {def_dir('GLOBAL',    d_global);}
      def_dir('INCLUDE',   d_include);
      def_dir('ORG',       d_org);
      def_dir('RADIX',     d_radix);

      def_dir('DB',        d_def_byte);
      def_dir('LSB',       d_def_lbyte);
      def_dir('MSB',       d_def_hbyte);
      def_dir('DW',        d_def_word);
      def_dir('DWP',       d_def_pword);
      def_dir('DWN',       d_def_nword);
      def_dir('DD',        d_def_long);
      def_dir('DDP',       d_def_plong);
      def_dir('DDN',       d_def_nlong);

      def_dir('DS',        d_def_space);

      def_dir('CHECKSUM',  d_chksum);

      def_dir('LIST',      d_list);
      def_dir('TRUNC',     d_trunc_list);

      def_dir('PROC',      d_procedure);
      def_dir('ENDP',      d_endproc);

      def_dir('SECTION',   d_section);
      def_dir('ENDS',      d_endsect);

      def_dir('PGM',       d_pgm);
      def_dir('OBJ',       d_obj);
      def_dir('CMD',       d_cmd);
      def_dir('BIN',       d_bin);

      def_dir('END',       d_end);

      n_drctv2:= n_cmd2;               {        heap- }
      d_nm_2:= mv2heap(cmd2, n_cmd2 * sizeof(cmd2[0]));
      d_cd_2:= mv2heap(cmd2_dir, n_cmd2 * sizeof(cmd2_dir[0]));
      n_drctv4:= n_cmd4;
      d_nm_4:= mv2heap(cmd4, n_cmd4 * sizeof(cmd4[0]));
      d_cd_4:= mv2heap(cmd4_dir, n_cmd4 * sizeof(cmd4_dir[0]));
      n_drctv6:= n_cmd6;
      d_nm_6:= mv2heap(cmd6, n_cmd6 * sizeof(cmd6[0]));
      d_cd_6:= mv2heap(cmd6_dir, n_cmd6 * sizeof(cmd6_dir[0]));
    end { init_directives };

  begin { lex_init }
    err_sy:= invalid_sy; save_src:= nil; lst_line:= nil; err_str:= nil;
    sy:= invalid_sy; src_file:= nil;     {       }
    total_lines:= 0; n_errors:= 0; n_warnings:= 0;
    cc_level:= 0; cc_compile:= 0; inc_nesting:= 0; proc_nesting:= 0;
    radix:= 10;
    termo_size:= MsgLimit - (ShowSize + 1 + 4 + 2 + 1 + (*) 3 {*) 4 {*});
    talk_style:= termometer; c_flags:= c_flags or _c_talkmem;
    i_path:= nil;

    with ls do begin
      IdName:= addr(idnm); IdSize:= 15;
      flags:= flag_ASCII +                                  { use 7 bit ASCII }
              flag_CKL +                      { case insensitive for keywords }
              flag_CCL;                     { do case correction in uppercase }
      buffer:= addr(src_buffer);                       { ptr to source buffer }
      buffsz:= 0;                                             { buffer's size }
      index:= 0;                                             { index   }
      start:= 0;                                          { start pos of item }
      KeyWordNo:= 0;                { Number of KeyWord (0 if not a key word) }
      new(bap(Classes));                       { ptr to byte array of classes }
      ClassAkw:= nil;                           { ptr to key words of class A }
      ClassBkw:= nil;                           { ptr to key words of class B }
      ClassCkw:= nil;                           { ptr to key words of class C }

      fillchar(c, 128, #0);                                  (*){$w-} begin (*)
      fillchar(c['A'], 26, char(class_A + class_A1));                  { A..Z }
      fillchar(c['a'], 26, char(class_A + class_A1));                  { a..z }
      fillchar(c['0'], 10, char(class_E + class_A1));                  { 0..9 }
                                                                   (*) end; (*)
      c['_']:= class_A + class_A1;

      c[#10]:= class_D; c[#12]:= class_D; c[#13]:= class_E;  {<lf>, <ff>, <cr>}

      c[#9]:= class_D; c[' ']:= class_D;                          {<tab>, <sp>}

      c[#26]:= class_E;                         { ctrl-Z (EOF char for MSDOS) }

      c['$']:= class_E; c['%']:= class_E; c['"']:= class_E; c['''']:= class_E;
      c['.']:= class_E; c['#']:= class_E; c[',']:= class_E; c['*']:= class_E;
      c['+']:= class_E; c['-']:= class_E; c['/']:= class_E; c['\']:= class_E;
      c['(']:= class_E; c[')']:= class_E; c['=']:= class_E; c[';']:= class_E;
      c['<']:= class_E; c['>']:= class_E; c['!']:= class_E; c['&']:= class_E;
      c['|']:= class_E; c['[']:= class_E; c[']']:= class_E; c[':']:= class_E;

      move(c, bap(classes)^, 128);
    end { with };
    fillchar(ch2sy_1part, sizeof(ch2sy_1part), char(invalid_sy));

    ch2sy_1part['!']:=  not_sy;
    ch2sy_1part['"']:=  dquote;
    ch2sy_1part['#']:=  dies;
    ch2sy_1part['&']:=  and_sy;
    ch2sy_1part['''']:= quote;
    ch2sy_1part['(']:=  l_par;
    ch2sy_1part[')']:=  r_par;
    ch2sy_1part['*']:=  asterisk;
    ch2sy_1part['+']:=  plus_sy;
    ch2sy_1part[',']:=  comma;
    ch2sy_1part['-']:=  minus_sy;
    ch2sy_1part['.']:=  period;
    ch2sy_1part['/']:=  slash_sy;

    init_commands;                        { command names: (ldaa, ldab, etc.) }
    init_alternate;               { alternate command names: (lda, ldb, etc.) }
    init_directives;              { directive names: (include, section, etc.) }

    fillchar(fnames, sizeof(fnames), #0);
    sect_include:= 0;           {         section }
  end { lex_init };

{-----------------------------------------------------------------------------}