{*****************************************************************************}
{*									     *}
{*			   Unit for Lexical Analisys			     *}
{*	  (c) 1990 Software Research & Development Laboratory, Sofia	     *}
{*                              version 1.50			             *}
{*									     *}
{*             Compile with UniPascal or Turbo Pascal Compiler               *}
{*									     *}
{*****************************************************************************}

unit UniLEX(*)(1_50)(*); interface
  const Class_D  = $01; 			       { separators (skipped) }
	Class_C  = $02; 				   { special keywords }
	Class_E  = $04; 				      { user handling }
	Class_A  = $08; 				{ Class A identifiers }
	Class_B  = $10; 				{ Class B identifiers }
	Class_A1 = $20; 			      { Class A' (A continue) }
	Class_B1 = $40; 			      { Class B' (B continue) }
	Class_C1 = $80; 			      { Class C' (C continue) }

	flag_EOB  = $01;	  { at end of buffer (may use odd to test it) }
	flag_CKC  = $02;		{ Case insensitive for keywords (cyr) }
	flag_CKL  = $04;		{ Case insensitive for keywords (lat) }
	flag_CCC  = $08;		 { Correct case for identifiers (cyr) }
	flag_CCL  = $10;		 { Correct case for identifiers (lat) }
        flag_LC   = $20;                      { Do case correction by LowCase }
	{unused   = $40;					 { unused now }
        flag_ASCII= $80;                     { use ASCII code only (#0..#127) }

  type token = (InvalidCh,				    { Classes[ch] = 0 }
		UserCh, 			 { start of user handled item }
		EndBuff,			     { Source buffer is empty }
		IdentA, 			      { Identifier of class A }
		IdentB, 			      { Identifier of class B }
		Akeyword,				 { KeyWord of class A }
		Bkeyword,				 { KeyWord of class B }
		Ckeyword);				 { KeyWord of class C }
									 (*){*)
       shortcard = byte;                    (* Turbo Pascal type definitions *)
       cardinal = word;
       natural = 0..32767;
       LongWord = LongInt;                                                  {*}

       LexStructure = packed record	     { structure for lexical analisys }
	 IdName:    pointer;				  { pointer to string }
	 IdSize:    ShortCard;			{ max length of an identifier }
	 flags:     byte;			     { see flag_XXX constants }
	 buffer:    pointer;			       { ptr to source buffer }
	 buffsz,					      { buffer's size }
	 index, 					     { index   }
	 start:     natural;				  { start pos of item }
	 KeyWordNo: natural;	    { Number of KeyWord (0 if not a key word) }
	 Classes:   pointer;		       { ptr to byte array of classes }
	 ClassAkw,				{ ptr to key words of class A }
	 ClassBkw,				{ ptr to key words of class B }
	 ClassCkw:  pointer;			{ ptr to key words of class C }
       end { LexStructure };

  function  ScanFor(ch: char; (*)const{*)var{*} source;
		    offset: cardinal; lim: integer): integer;
    (*) code $5f, $13, 1; (*)

  function  ScanNotFor(ch: char; (*)const{*)var{*} source;
		       offset: cardinal; lim: integer): integer;
    (*) code $5f, $13, 0; (*)

  function TokenSearch(var ls: LexStructure): token;
    (*) code $5f, $12; (*)

  function GetInteger((*)const{*)var{*}Src;offset:word;limit:word;var EndPos:word): LongInt;
    (*) code $5f, $14, $30; (*)

  function GetReal((*)const{*)var{*}Src; offset: word; limit: word; var EndPos: word): Real;
    (*) code $5f, $14, $b0; (*)

  function  UpCaseCyr(ch: char): char;
    (*) code $5f, $34, $82; (*)

  procedure Int2Str(Value: LongInt; var s: string(*)[11](*));
    (*) code 11, $5f, $15, $0; (*)

  function  LoCase(ch: char): char;
    (*) code $5f, $34, $00; (*)

  function  LoCaseCyr(ch: char): char;
    (*) code $5f, $34, $02; (*)

  procedure UpCaseS(var s: string(*)[1](*));
    (*) code $5f, $34, $81; (*)

  procedure UpCaseSCyr(var s: string(*)[1](*));
    (*) code $5f, $34, $83; (*)

  procedure LoCaseS(var s: string(*)[1](*));
    (*) code $5f, $34, $01; (*)

  procedure LoCaseSCyr(var s: string(*)[1](*));
    (*) code $5f, $34, $03; (*)

  procedure Real2Str (R: real; W: Natural; var S: string(*)[79](*));
    (*) code $80, 79, $5f, $15, $81; (*)    { W -     }

  procedure Exp2Str(R: real; W: Natural; var S: string(*)[15](*));
    (*) code 15, $5f, $15, $80; (*) {W-    }

  procedure Long2Str(Value: LongWord; var s: string(*)[8](*));
    (*) code 8, $5f, $15, $1; (*)

  procedure Word2Str(Value: LongWord; var s: string(*)[4](*));
    (*) code 4, $5f, $15, $2; (*)

  procedure Byte2Str(Value: LongWord; var s: string(*)[2](*));
    (*) code 2, $5f, $15, $3; (*)

  function Compare(limit: natural;
                   (*) const {*) var {*} Src;  SRCoffset:  natural;
                   (*) const {*) var {*} Dest; Destoffset: natural): natural;
    (*) code $5f, $1a; (*)

(*) end. {*) implementation { for Turbo Pascal }

  type ba = packed array [0..1000] of byte;
       ca = packed array [0..1000] of char;

  function TokenSearch(var ls: LexStructure): token;
    type cap = ^ca;
	 bap = ^ba;
    var ch: char;
	Sz: byte;
	ASCIIonly: boolean;
	Class: byte;

    function SearchTbl(tbl: pointer; var sz: byte): word;
      type bap = ^ba;
      var lastno, curno: word;
	  ndx, bndx, nextndx: word;
	  cursz, lastsz:  byte;
	  ch: char;
	  UpCaseC, UpcaseL: boolean;
    begin
    Sz:= 0; lastno:= 0; ndx:= 0; curno:= 0;
    UpCaseL:= ls.flags and $04 <> 0; UpCaseC:= ls.flags and $02 <> 0;
    if tbl <> nil
      then begin cursz:= bap(tbl)^[ndx]; bndx:= ls.start;
	   while (cursz <> 0) and (bndx <> ls.index) do
	     begin inc(curno); lastsz:= cursz; bndx:= ls.start;
	     nextNdx:= succ(ndx + cursz);
	     repeat inc(ndx); ch:= char(bap(ls.buffer)^[bndx]);
	       if UpCaseL and (ch in ['a'..'z']) or
		  UpCaseC and (ch in [''..''])
		 then dec(ch, $20);
	       dec(cursz, ord(ch = char(bap(tbl)^[ndx]))); inc(bndx);
	     until (ch <> char(bap(tbl)^[ndx])) or
		   (cursz = 0) or (bndx = ls.index);

	     if (cursz = 0) and (Sz < LastSz)
	       then begin lastno:= curno; sz:= lastsz; end;
	     ndx:= nextNdx; dec(bndx, cursz);
	     cursz:= bap(tbl)^[ndx];
	     end { while };
	   end;
    SearchTbl:= lastno;
    end { SearchTbl };

    function  FetchIdent(class: byte;
			 IDtoken, KWtoken: token;
			 tbl: pointer): token;
      var ch, ch_: char;
	  strp: ^string;
	  wrks: string[3];
	  UpCaseL,
	  UpCaseC: boolean;
	  LoCase: byte;
	  IdSz:  byte;
    begin
    with ls do
      begin strp:= IdName; LoCase:= flags and $20; IdSz:= IdSize;
      UpCaseL:= flags and $10 <> 0; UpCaseC:= flags and $08 <> 0;
      if strp = nil
	then begin strp:= addr(wrks); IdSz:= 2; end;
      strp^:= ''; ch:= cap(buffer)^[index];
      repeat ch_:= chr(ord(ch) and $df);
	if UpCaseL and (ch_ in ['A'..'Z']) or UpCaseC and (ch in [''..''])
	  then ch:= chr(ord(ch_) or LoCase);
	if length(strp^) < IdSz
	  then begin inc(strp^[0]);
	       strp^[length(strp^)]:= ch;		   {    }
	       end;
	inc(index);				   {   }
	ch:= cap(buffer)^[index];
      until ((#128 <= ch) and ASCIIonly) or
	    (bap(Classes)^[ord(ch)] and class = 0) or
	    (index = buffsz);

(*    FillChar(strp^[succ(length(strp^))], IdSz - length(strp^), ' '); *)

      KeyWordNo:= SearchTbl(tbl, Sz);
      if start + Sz = index
	then FetchIdent:= KWtoken
	else begin KeyWordNo:= 0; FetchIdent:= IDtoken; end;
      end { with };
    end { FetchIdent };

  begin
  with ls do
    begin ASCIIonly:= flags and $80 <> 0; flags:= flags or 1; { end of buffer }
    start:= index;
    if buffsz <= index
      then TokenSearch:= EndBuff			      {     }
      else begin ch:= cap(buffer)^[index];		       { skip Class D }
	   while ((ch <= #127) or not ASCIIonly) and
		 (bap(Classes)^[ord(ch)] and Class_D <> 0) and
		 (index < buffsz) do
	     begin inc(index); ch:= cap(buffer)^[index]; end;
	   start:= index;
	   if index = buffsz
	     then begin TokenSearch:= EndBuff; exit end;
	   flags:= flags and $fe;
	   if ((ch <= #127) or not ASCIIonly) and	 { Class C character? }
	      (bap(Classes)^[ord(ch)] and Class_C <> 0) and (ClassCkw <> nil)
	     then begin Sz:= 0; {    C,C',C',...  }
		  repeat inc(index); inc(Sz);
		    ch:= cap(buffer)^[index];
		  until ((#128 < ch) and ASCIIonly) or
			(bap(Classes)^[ord(ch)] and Class_C1 = 0) or
			(index = buffsz);
		  KeyWordNo:= SearchTbl(ClassCkw, Sz);
		  index:= start + Sz;
		  if KeyWordNo <> 0
		    then begin TokenSearch:= Ckeyword;
			 flags:= flags or ord(index = buffsz);
			 exit;
			 end;
		  ch:= cap(buffer)^[index];
		  end;

	   if ((ch < #128) or not ASCIIonly) and	 { Class E character? }
	      (bap(Classes)^[ord(ch)] and Class_E <> 0)
	     then begin TokenSearch:= UserCh; inc(index); end
	   else if ((ch < #128) or not ASCIIonly) and	 { Class A character? }
		     (bap(Classes)^[ord(ch)] and Class_A <> 0)
	     then TokenSearch:= FetchIdent(Class_A1, IdentA, Akeyword, ClassAkw)
	   else if ((ch < #128) or not ASCIIonly) and	 { Class B character? }
		     (bap(Classes)^[ord(ch)] and Class_B <> 0)
	     then TokenSearch:= FetchIdent(Class_B1, IdentB, Bkeyword, ClassBkw)
	   else begin TokenSearch:= InvalidCh; inc(index); end;   { Invalid char }

	   flags:= flags or ord(index = buffsz);
	   end;
    end { with };
  end { TokenSearch };

  function GetInteger(var Src; offset: word; limit: word; var EndPos: word):
	    LongInt;
    type ca = packed array [0..0] of char;
    var nodigits, hex: boolean;
        has_sign: boolean;
	radix: byte;
	num: LongInt;
	ch: char;
	cap: ^ca;
        start: byte;
  begin
    NoDigits:= false; system.InOutRes:= 0;
    cap:= addr(ca(Src)[offset]);
    start:= 0; has_sign:= false;
    repeat
      if nodigits then begin { }
        inc(EndPos); inc(start);
      end { if };
      while (start < limit) and (cap^[start] = ' ') do begin
        inc(EndPos); inc(start);
      end { while };
      has_sign:= has_sign or (start < limit) and (cap^[start] = '-');
      if nodigits and (start<limit) and (cap^[start] in ['-','+']) then begin
        system.InOutRes:= -1;
      end { if };
      nodigits:= true; {   }
    until (start >= limit) or not (cap^[start] in ['-', '+']);
    NoDigits:= true;
    hex:= cap^[start] = '$'; radix:= 10 + ord(hex)*6;
    EndPos:= ord(hex) + start; num:= 0; ch:= '_';
    while (ch = '_') and (EndPos < limit) do begin
      ch:= UpCase(cap^[EndPos]);
      while (EndPos < limit) and
	    (('0' <= ch) and (ch <= '9') or
	     hex and ('A' <= ch) and (ch <= 'F')) do begin
        num:= num * radix - ord('0') + ord(ch);
        if 'A' <= ch then num:= num - 7;
        Inc(EndPos); ch:= UpCase(cap^[EndPos]);
        NoDigits:= false;
      end { while };
      while (EndPos < limit) and (ch = '_') do begin
        inc(EndPos, 1);
      end { while };
    end { while };
    if has_sign then num:= -num;
    GetInteger:= num;
    if NoDigits then system.InOutRes:= -1;
  end { GetInteger };

  function GetReal(var Src; offset: word; limit: word; var EndPos: word): Real;
    type ca = packed array [0..1000] of char;
    var Ipart, Fpart, Epart: LongInt;
        cap: ^ca; r: real; code, start: integer; s: string;
  begin
  EndPos:= 0; cap:= addr(ca(Src)[offset]); system.InOutRes:= 0; start:= 0;
  while (EndPos < limit) and (cap^[EndPos] = ' ') do begin
    inc(EndPos); inc(start);
  end { while };
  while (EndPos < limit) and (cap^[EndPos] in ['0'..'9', '_']) do Inc(EndPos);
  if (cap^[EndPos] = '.') and (EndPos < limit)
    then repeat Inc(EndPos)
	 until (limit <= EndPos) or not (cap^[EndPos] in ['0'..'9', '_']);
  if (upcase(cap^[EndPos]) = 'E') and (EndPos < limit)
    then begin Inc(EndPos); inc(EndPos, ord(cap^[EndPos] = '_'));
	 if ((cap^[EndPos] = '+') or (cap^[EndPos] = '-')) and
	    (EndPos < limit)
	   then Inc(EndPos);
	 while (EndPos < limit) and (cap^[EndPos] in ['0'..'9', '_']) do
	   Inc(EndPos);
	 end;
  if EndPos = 0 then exit;
  s[0]:= chr(EndPos-start); Move(cap^[start], s[1], EndPos-start);
  while pos('_', s) <> 0 do delete(s, pos('_', s), 1);
  Val(s, r, code);
  if code <> 0 then system.InOutRes:= -1;
  getreal:= r;
  end { GetReal };

  function ScanFor(ch: char; var source; offset: word; lim: integer): integer;
    label exit;
    type ca = packed array [0..10000] of char;
    var i: integer;
	cap: ^ca;
  begin
    i:= 0; cap:= addr(ca(source)[offset]);
    if lim >= 0 then
      while i < lim do begin
	if cap^[i] = ch then goto Exit;
	Inc(i);
      end { while }
    else begin
      while i > lim do begin
	if cap^[i] = ch then goto Exit;
	Dec(i);
      end { while };
    end { if };
exit:
    ScanFor:= i;
  end { ScanFor };

  function ScanNotFor(ch: char; var source; offset: word; lim: integer): integer;
    label exit;
    type ca = packed array [0..10000] of char;
    var i: integer;
	cap: ^ca;
  begin
    i:= 0; cap:= addr(ca(source)[offset]);
    if lim >= 0 then
      while i < lim do begin
	if cap^[i] <> ch then goto Exit;
	Inc(i);
      end { while }
    else begin
      while i > lim do begin
	if cap^[i] <> ch then goto Exit;
	Dec(i);
      end { while };
    end { if };
exit:
    ScanNotFor:= i;
  end { ScanNotFor };

  function UpCaseCyr(ch: char): char;
  begin
    if ord(ch) < 128 then
      UpCaseCyr:= upcase(ch)
    else if (ord('') <= ord(ch)) and (ord(ch) <= ord('')) then
      UpCaseCyr:= chr(ord(ch) - 32)
    else begin
      UpCaseCyr:= ch;
    end { if };
  end { UpCaseCyr };

  function  LoCase(ch: char): char;
  begin
    if ('A' <= ch) and (ch <= 'Z') then dec(ch, 32);
    LoCase:= ch;
  end { LoCase };

  function  LoCaseCyr(ch: char): char;
  begin
    if ('A' <= ch) and (ch <= 'Z') or
       ('' <= ch) and (ch <= '') then dec(ch, 32);
    LoCaseCyr:= ch;
  end { LoCaseCyr };

  procedure UpCaseS(var s: string);
    var i: byte;
  begin
    for i:= 0 to length(s) do begin
      if s[i] in ['a'..'z'] then dec(s[i], 32);
    end { for };
  end { UpCaseS };

  procedure UpCaseSCyr(var s: string);
    var i: byte;
  begin
    for i:= 0 to length(s) do begin
      if s[i] in ['a'..'z', ''..''] then dec(s[i], 32);
    end { for };
  end { UpCaseSCyr };

  procedure LoCaseS(var s: string);
    var i: byte;
  begin
    for i:= 0 to length(s) do begin
      if s[i] in ['A'..'Z'] then inc(s[i], 32);
    end { for };
  end { LoCaseS };

  procedure LoCaseSCyr(var s: string);
    var i: byte;
  begin
    for i:= 0 to length(s) do begin
      if s[i] in ['A'..'Z', ''..''] then inc(s[i], 32);
    end { for };
  end { LoCaseSCyr };

  procedure Int2Str(Value: LongInt; var s: string(*)[11](*));
  begin
    str(value, s);
  end { Int2Str };

  procedure Real2Str (R: real; W: Natural; var S: string);
  begin
    str(r:0:w, s);
  end { real2str };

  procedure Exp2Str(R: real; W: Natural; var S: string);
  begin
    str(r:w, s);
  end { exp2str };

  function Compare(limit: natural;
                   var Src;  SRCoffset:  natural;
                   var Dest; Destoffset: natural): natural;
    var i, j, l: natural;
  begin { Compare }
    i:= SRCoffset; j:= Destoffset; l:= 0;
    while (l < limit) and (ba(src)[i] = ba(dest)[j]) do begin
      inc(i); inc(j); inc(l);
    end { while };
    Compare:= l;
  end { Compare };

  const hexs: packed array [0..15] of char = '0123456789abcdef';

  procedure Byte2Str(Value: LongWord; var s: string(*)[2](*));
  begin
    s:= hexs[Value div 16] + hexs[Value mod 16];
  end { Byte2Str };

  procedure Word2Str(Value: LongWord; var s: string(*)[4](*));
    var s1: string[2];
  begin
    Byte2Str(hi(Value), s1); Byte2Str(lo(Value), s); insert(s1, s, 1);
  end { Word2Str };

  procedure Long2Str(Value: LongWord; var s: string(*)[8](*));
    var s1: string[4];
  begin
    Word2Str(Value div 65536, s1); Word2Str(Value, s); insert(s1, s, 1);
  end { Long2Str };

end.